#!/bin/sh
#----------------------------------------------------------------------------
# /tmp/preinstall.sh - cyrus-sasl preinstallation
#
# Creation   :  2017-06-06 holbru
# Last update:  $Id: preinstall.sh 88804 2021-07-20 15:27:22Z hbfl $
#
# Copyright (c) 2017-2023 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------

# set package name
package_name=cyrus-sasl

# ---------------------------------------------------------------------------
# Convert password file from berkely into gdbm
# ---------------------------------------------------------------------------
installed=$(eisman check ${package_name} 3.2.0)

if [ "${installed}" = "new" ]
then 

if [ -e /etc/sasldb2 ]
then
cat <<EOF > /var/tmp/saslpw.awk
{
        split(\$0,b,/\\\00/)
        if( b[3] == "userPassword" ) {
                user=b[1]
                domain=b[2]
        } else {
                if( user != "" ) {
                        printf("echo '%s' | saslpasswd2 -p -u %s %s\n",substr(b[1],2),user,domain)
                        user = ""
                        domain = ""
                }
        }
}
EOF
    if [ ! -f /usr/bin/db_dump ]
    then
        ( 
            /usr/bin/eisman install --auto db5-3-utils  
        ) 
    fi 

    /usr/bin/db_dump -p /etc/sasldb2 | /usr/bin/gawk -f /var/tmp/saslpw.awk > /var/tmp/saslpwd
    /usr/bin/rm -f /var/tmp/saslpw.awk
    /usr/bin/mv /etc/sasldb2 /etc/sasldb2-back
fi

fi

exit 0
# ---------------------------------------------------------------------------
# end
# ---------------------------------------------------------------------------
